## kcov 4

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)


# ====================================
# project name and version
# ====================================
project (kcov)
set (PACKAGE_VERSION_MAJOR  4)
set (PACKAGE_VERSION_MINOR  0)
set (PACKAGE_VERSION_PATCH  0)

if(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE debug)
endif(NOT CMAKE_BUILD_TYPE)

# ====================================
# configuring
# ====================================
set (CMAKE_MODULE_PATH  ${CMAKE_MODULE_PATH}
                        ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
find_package (PkgConfig REQUIRED)
pkg_check_modules (GLIB2 REQUIRED glib-2.0)
pkg_check_modules (LIBELF libelf)
if (NOT LIBELF_FOUND)
    find_package (LibElf REQUIRED)
endif (NOT LIBELF_FOUND)
pkg_check_modules (LIBDWARF libdwarf)
if (NOT LIBDWARF_FOUND)
    find_package (LibDwarf REQUIRED)
endif (NOT LIBDWARF_FOUND)


# ====================================
# default install paths for targets
# ====================================
include (CPack.local.cmake OPTIONAL)
set (INSTALL_TARGETS_DEFAULT_ARGS RUNTIME DESTINATION bin
                                  LIBRARY DESTINATION lib
                                  ARCHIVE DESTINATION lib)


# ====================================
# build all
# ====================================
add_subdirectory (src)

=== debian/changelog ===
kcov (4-2) unstable; urgency=low

  * Fix FTBFS on ia64 by removing include of asm/ptrace.h

 -- Michael Tautschnig <mt@debian.org>  Fri, 17 Dec 2010 23:35:00 +0100

kcov (4-1) unstable; urgency=low

  * New upstream release
    - Fixes FTBFS on non-x86 architectures (closes: #603135).

 -- Michael Tautschnig <mt@debian.org>  Fri, 17 Dec 2010 10:03:23 +0100

kcov (3-1) unstable; urgency=low

  * New upstream release
  * Fixed watch file
  * Updated man page

 -- Michael Tautschnig <mt@debian.org>  Sun, 05 Dec 2010 10:05:16 +0100

kcov (2-1) unstable; urgency=low

  * Initial release (Closes: #601937), includes all upstream patches up to
    b7a7a123864fa4062ca1f1501cae9966c153af5e

 -- Michael Tautschnig <mt@debian.org>  Sun, 31 Oct 2010 11:10:29 +0100

=== debian/control ===
Source: kcov
Section: devel
Priority: extra
Maintainer: Michael Tautschnig <mt@debian.org>
Build-Depends: debhelper (>= 7.0.50~), libelf-dev, libdwarf-dev, pkg-config, libglib2.0-dev, cmake
Standards-Version: 3.9.1
Homepage: http://simonkagstrom.github.com/kcov/
Vcs-Git: git://github.com/SimonKagstrom/kcov.git

Package: kcov
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Code coverage analysis using DWARF debugging information
 Kcov is a code coverage tester based on bcov by Thomas Neumann. It allows
 collecting code coverage information from executables without special
 command-line arguments, and continuosly produces output from long-running
 applications. 
 .
 Kcov, like Bcov, uses DWARF debugging information to make this possible.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_clean:
	dh_testdir
	dh_auto_clean
	dh_clean
	rm -rf obj-* CMakeFiles CMakeCache.txt

## kcov 5

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,12 +5,14 @@
 # project name and version
 # ====================================
 project (kcov)
-set (PACKAGE_VERSION_MAJOR  4)
-set (PACKAGE_VERSION_MINOR  0)
-set (PACKAGE_VERSION_PATCH  0)
+set (PROJECT_VERSION_MAJOR  4)
+set (PROJECT_VERSION_MINOR  0)
+set (PROJECT_VERSION_PATCH  0)
+set (PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
+
 
 if(NOT CMAKE_BUILD_TYPE)
-  SET(CMAKE_BUILD_TYPE debug)
+  set (CMAKE_BUILD_TYPE  Debug)
 endif(NOT CMAKE_BUILD_TYPE)
 
 # ====================================

=== src/CMakeLists.txt ===
set (kcov_SRCS
    arch/arch.c
    kc.c
    kc_addr.c
    kc_elf.c
    kc_file.c
    kc_line.c
    kc_ptrace.c
    kprobe_coverage.c
    main.c
    report.c
    utils.c)
include_directories (include/)
include_directories (${GLIB2_INCLUDE_DIRS})
include_directories (${LIBELF_INCLUDE_DIRS})
include_directories (${LIBDWARF_INCLUDE_DIRS})

add_executable (${PROJECT_NAME} ${kcov_SRCS})

target_link_libraries (${PROJECT_NAME} ${GLIB2_LIBRARIES})
target_link_libraries (${PROJECT_NAME} ${LIBELF_LIBRARIES})
target_link_libraries (${PROJECT_NAME} ${LIBDWARF_LIBRARIES})
target_link_libraries (${PROJECT_NAME} pthread)

install (TARGETS ${PROJECT_NAME} ${INSTALL_TARGETS_DEFAULT_ARGS})

=== debian/changelog ===
kcov (5-1ubuntu1) quantal; urgency=low

  * 01-fix-ppc32-pc-offset.patch: The PC offset is 32, not 33 (NIP).
    (LP: #919296)

 -- Ben Collins <bcollins@ubuntu.com>  Wed, 13 Jun 2012 16:15:54 -0400

kcov (5-1) unstable; urgency=low

  * New upstream version
    - Added all upstream patches up to ed83e132c6d5736cc75

 -- Michael Tautschnig <mt@debian.org>  Tue, 29 Mar 2011 00:01:40 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: kcov
 Section: devel
 Priority: extra
-Maintainer: Michael Tautschnig <mt@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), libelf-dev, libdwarf-dev, pkg-config, libglib2.0-dev, cmake
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Michael Tautschnig <mt@debian.org>
+Build-Depends: debhelper (>= 7.0.50~), libdw-dev, libelf-dev, pkg-config, libglib2.0-dev, cmake
 Standards-Version: 3.9.1
 Homepage: http://simonkagstrom.github.com/kcov/
 Vcs-Git: git://github.com/SimonKagstrom/kcov.git

=== debian/rules ===
--- 
+++ 
@@ -17,4 +17,23 @@
 	dh_auto_clean
 	dh_clean
 	rm -rf obj-* CMakeFiles CMakeCache.txt
+	rm -rf tests-build
 
+ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
+ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
+override_dh_auto_test:
+	dh_testdir
+	-mkdir tests-build
+	cd tests-build ; cmake ../tests/
+	$(MAKE) -C tests-build
+	ls
+	cd tests-build ; export PATH=`echo $$PWD/../obj-*/src`:$$PATH ; \
+		sh run-all.sh 2>&1 | tee tests.log
+	rm -rf /tmp/kcov
+	if grep -q FAIL tests-build/tests.log ; then \
+		echo "Test suite failure" ; \
+		exit 1 ; \
+	fi
+endif
+endif
+

=== debian/watch ===
version=3
http://githubredir.debian.net/github/SimonKagstrom/kcov/v(.+).tar.gz

## kcov 11

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)


# ====================================
# project name and version
# ====================================
project (kcov)
set (PROJECT_VERSION_MAJOR  11)
set (PROJECT_VERSION_MINOR  0)
set (PROJECT_VERSION_PATCH  0)
set (PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")


if(NOT CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE  Release)
endif(NOT CMAKE_BUILD_TYPE)

# ====================================
# configuring
# ====================================
set (CMAKE_MODULE_PATH  ${CMAKE_MODULE_PATH}
                        ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
find_package (PkgConfig REQUIRED)


# ====================================
# default install paths for targets
# ====================================
include (CPack.local.cmake OPTIONAL)
set (INSTALL_TARGETS_PATH RUNTIME DESTINATION bin
                          LIBRARY DESTINATION lib${LIB_SUFFIX}
                          ARCHIVE DESTINATION lib${LIB_SUFFIX})
if (NOT MAN_DIR)
  set (MAN_DIR share/man)
endif (NOT MAN_DIR)
set (INSTALL_MAN_PATH  DESTINATION ${MAN_DIR})


# ====================================
# build all
# ====================================
add_subdirectory (src)
add_subdirectory (doc)

=== doc/CMakeLists.txt ===
file (GLOB man_files_1  *.1)

install (FILES ${man_files_1} ${INSTALL_MAN_PATH}/man1)

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project (kcov)
set (CMAKE_MODULE_PATH  ${CMAKE_MODULE_PATH}
                        ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake)
find_package (LibElf REQUIRED)
find_package (LibDwarf REQUIRED)

# ====================================
# project name and version
# ====================================
project (kcov)
set (TGT kcov)

set (SOLIB kcov_sowrapper)

set (${SOLIB}_SRCS
	solib-parser/phdr_data.c
	solib-parser/lib.c
	)

set (${TGT}_SRCS
    cobertura-writer.cc
    collector.cc
    configuration.cc
    elf.cc
    filter.cc
    html-writer.cc
    main.cc
    output-handler.cc
    ptrace.cc
    reporter.cc
    solib-parser/phdr_data.c
    utils.cc
    writer-base.cc
    )


set (KCOV_LIBRARY_PREFIX "/tmp")

set (CMAKE_CXX_FLAGS "-std=c++0x -Wall -D_GLIBCXX_USE_NANOSLEEP -DKCOV_LIBRARY_PREFIX=${KCOV_LIBRARY_PREFIX}")

include_directories(
	include/
	${LIBELF_INCLUDE_DIRS}
	${LIBDWARF_INCLUDE_DIRS}
	)

link_directories (/home/ska/local/lib)

add_library (${SOLIB} SHARED ${${SOLIB}_SRCS})

add_custom_command(
   OUTPUT library.c
   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py lib${SOLIB}.so > library.c
   DEPENDS ${SOLIB}
   )


add_executable (${TGT} ${${TGT}_SRCS} library.c)

target_link_libraries(${TGT}
	${LIBDWARF_LIBRARIES}
	${LIBELF_LIBRARIES}
	dl
	pthread)

install (TARGETS ${PROJECT_NAME} ${INSTALL_TARGETS_PATH})

=== tests/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project (kcov-tests)

set (main_tests_SRCS
	main.cc
	subdir/file.c
	subdir2/file.c
)

set (argv_dependent_SRCS
	argv-dependent.c
)

set (fork_SRCS
	fork/fork.c
)

set (fork_no_wait_SRCS
	fork/fork-no-wait.c
)

set (recursive-ptrace_SRCS
	recursive-ptrace/main.cc
)

set (shared_library_test_SRCS
	shared-library/main.c
)

set (test_popen_SRCS
	popen/test-popen.c
)


add_library(shared_library SHARED shared-library/solib.c)


set(CMAKE_BUILD_TYPE distribution)
set(CMAKE_C_FLAGS_DISTRIBUTION "-g")
set(CMAKE_CXX_FLAGS_DISTRIBUTION "-g")


find_library(shared_library_LIBRARY
  NAMES shared_library
  PATHS ${CMAKE_CURRENT_BINARY_DIR}
)


add_executable(main-tests ${main_tests_SRCS})
add_executable(recursive-ptrace ${recursive-ptrace_SRCS})
add_executable(fork ${fork_SRCS})
add_executable(fork_no_wait ${fork_no_wait_SRCS})
add_executable(shared_library_test ${shared_library_test_SRCS})
add_executable(argv_dependent ${argv_dependent_SRCS})
add_executable(test_popen ${test_popen_SRCS})

target_link_libraries(shared_library_test shared_library)


add_custom_target(tests-stripped ALL
	COMMAND strip -o tests-stripped main-tests)

=== src/kernel/Makefile ===
KDIR := /lib/modules/$(shell uname -r)/build
PWD := $(shell pwd)

CFLAGS_kmod.o += -g3

obj-m += kmod.o

default:
	$(MAKE) -C $(KDIR) SUBDIRS=$(PWD) modules

clean:
	rm -f *.o *.ko *.order *.symvers *.mod.c

=== tests/unit-tests/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project (kcov-ut)
set (CMAKE_MODULE_PATH  ${CMAKE_MODULE_PATH}
                        ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake)
find_package (LibCRPCUT REQUIRED)
find_package (LibElf REQUIRED)
find_package (LibDwarf REQUIRED)
find_package (GTest REQUIRED)
find_package (GMock REQUIRED)

# ====================================
# project name and version
# ====================================
project (unit-test)
set (TGT ut)

set (${TGT}_SRCS
    ../../src/cobertura-writer.cc
    ../../src/collector.cc
    ../../src/elf.cc
    ../../src/output-handler.cc
    ../../src/reporter.cc
    ../../src/utils.cc
    ../../src/html-writer.cc
    ../../src/writer-base.cc
    main.cc
    tests-collector.cc
    tests-elf.cc
    tests-filter.cc
    tests-reporter.cc
    tests-writer.cc
    tests-configuration.cc
    )
set (CMAKE_BUILD_TYPE debug)

set (CMAKE_CXX_FLAGS "-std=c++0x -Wall -D_GLIBCXX_USE_NANOSLEEP")


include_directories(
	../../src/include/
	${GMOCK_INCLUDE_DIRS}
	${GTEST_INCLUDE_DIRS}
	${LIBCRPCUT_INCLUDE_DIRS}
	${LIBELF_INCLUDE_DIRS}
	${LIBDWARF_INCLUDE_DIRS}
	)

link_directories (/home/ska/local/lib)

add_executable (${TGT} ${${TGT}_SRCS})

target_link_libraries(${TGT}
	${LIBCRPCUT_LIBRARIES}
	${GTEST_BOTH_LIBRARIES}
	${GMOCK_BOTH_LIBRARIES}
	${LIBDWARF_LIBRARIES}
	${LIBELF_LIBRARIES}
	dl
	pthread)

add_executable (same-name-test
	../main.cc
	../subdir/file.c
	../subdir2/file.c
)
  
add_executable (test-binary test-source.c second-source.c)
SET_TARGET_PROPERTIES(test-binary PROPERTIES COMPILE_FLAGS "-nostdinc")
SET_TARGET_PROPERTIES(test-binary PROPERTIES LINK_FLAGS "-nostdlib")

=== debian/changelog ===
kcov (11-1) unstable; urgency=low

  * New upstream version
  * Proper packaging (closes: #643174)
  * Make it architecture i386 and amd64 only, others are not supported
    (closes: #650738)
  * Bump Standards Version to 3.9.4 (no changes)

 -- Michael Tautschnig <mt@debian.org>  Sun, 02 Dec 2012 15:43:07 +0000

=== debian/control ===
Source: kcov
Section: devel
Priority: extra
Maintainer: Michael Tautschnig <mt@debian.org>
Build-Depends: debhelper (>= 7.0.50~), libdw-dev, libelf-dev, pkg-config, libglib2.0-dev, cmake, python
Standards-Version: 3.9.4
Homepage: http://simonkagstrom.github.com/kcov/
Vcs-Git: git://github.com/SimonKagstrom/kcov.git

Package: kcov
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Code coverage analysis using DWARF debugging information
 Kcov is a code coverage tester based on bcov by Thomas Neumann. It allows
 collecting code coverage information from executables without special
 command-line arguments, and continuosly produces output from long-running
 applications. 
 .
 Kcov, like Bcov, uses DWARF debugging information to make this possible.

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
 override_dh_auto_test:
 	dh_testdir
-	-mkdir tests-build
+	mkdir tests-build
 	cd tests-build ; cmake ../tests/
 	$(MAKE) -C tests-build
 	ls

=== debian/watch ===
version=3
https://github.com/SimonKagstrom/kcov/tags .*/v(\d.*)\.(?:tgz|tar\.(?:gz|bz2|xz))
# Bart Martens <bartm@debian.org>  Sat, 17 Nov 2012 13:00:16 +0000

## kcov 25%2Bdfsg

=== debian/control ===
Source: kcov
Section: devel
Priority: extra
Maintainer: Michael Tautschnig <mt@debian.org>
Build-Depends: debhelper (>= 7.0.50~), libdw-dev, libelf-dev, pkg-config,
 libglib2.0-dev, cmake, python, libjs-handlebars,
 libcurl4-openssl-dev, libjs-jquery
Standards-Version: 3.9.6
Homepage: http://simonkagstrom.github.com/kcov/
Vcs-Git: git://github.com/SimonKagstrom/kcov.git

Package: kcov
Architecture: i386 amd64 powerpc arm64 armel armhf ppc64el powerpcspe ppc64 x32
 hurd-i386 kfreebsd-amd64 kfreebsd-i386
Depends: python, ${shlibs:Depends}, ${misc:Depends}
Description: Code coverage analysis using DWARF debugging information
 Kcov is a code coverage tester based on bcov by Thomas Neumann. It allows
 collecting code coverage information from executables without special
 command-line arguments, and continuosly produces output from long-running
 applications. 
 .
 Kcov, like Bcov, uses DWARF debugging information to make this possible.

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
https://github.com/SimonKagstrom/kcov/tags .*/v(\d.*)\.(?:tgz|tar\.(?:gz|bz2|xz))
# Bart Martens <bartm@debian.org>  Sat, 17 Nov 2012 13:00:16 +0000

## kcov 25+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,11 +5,6 @@
 # project name and version
 # ====================================
 project (kcov)
-set (PROJECT_VERSION_MAJOR  11)
-set (PROJECT_VERSION_MINOR  0)
-set (PROJECT_VERSION_PATCH  0)
-set (PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
-
 
 if(NOT CMAKE_BUILD_TYPE)
   set (CMAKE_BUILD_TYPE  Release)
@@ -22,6 +17,7 @@
                         ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 find_package (PkgConfig REQUIRED)
 
+set (SPECIFY_RPATH OFF CACHE BOOL "Specify RPATH for installed executables")
 
 # ====================================
 # default install paths for targets

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project (kcov)
set (CMAKE_MODULE_PATH  ${CMAKE_MODULE_PATH}
                        ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake)
find_package (LibElf REQUIRED)
find_package (Elfutils REQUIRED)
pkg_check_modules(LIBZ REQUIRED zlib)
pkg_check_modules(LIBCURL REQUIRED libcurl)

# ====================================
# project name and version
# ====================================
project (kcov)
set (KCOV kcov)
#set (CMAKE_EXE_LINKER_FLAGS "-static")

set (SOLIB kcov_sowrapper)

set (${SOLIB}_SRCS
	solib-parser/phdr_data.c
	solib-parser/lib.c
	)

set (${KCOV}_SRCS
    capabilities.cc
    collector.cc
    configuration.cc
    engine-factory.cc
    engines/bash-engine.cc
    engines/gcov-engine.cc
    engines/kernel-engine.cc
    engines/ptrace.cc
    engines/python-engine.cc
    filter.cc
    gcov.cc
    main.cc
    merge-file-parser.cc
    output-handler.cc
    parsers/elf-parser.cc
    parser-manager.cc
    reporter.cc
    solib-handler.cc
    solib-parser/phdr_data.c
    utils.cc
    writers/cobertura-writer.cc
    writers/coveralls-writer.cc
    writers/html-writer.cc
    writers/writer-base.cc
    )


set (KCOV_LIBRARY_PREFIX "/tmp")

set (CMAKE_CXX_FLAGS "-std=c++0x -g -Wall -D_GLIBCXX_USE_NANOSLEEP -DKCOV_LIBRARY_PREFIX=${KCOV_LIBRARY_PREFIX}")

include_directories(
	include/
	${LIBELF_INCLUDE_DIRS}
	${LIBDW_INCLUDE_DIRS}
	${LIBZ_INCLUDE_DIRS}
	${LIBCURL_INCLUDE_DIRS}
	)

link_directories (/home/ska/local/lib)

add_library (${SOLIB} SHARED ${${SOLIB}_SRCS})

target_link_libraries(${SOLIB} dl)

add_custom_command(
   OUTPUT library.cc
   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py lib${SOLIB}.so __library > library.cc
   DEPENDS ${SOLIB} ${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py
   )

add_custom_command(
   OUTPUT python-helper.cc
   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py ${CMAKE_CURRENT_SOURCE_DIR}/engines/python-helper.py  python_helper > python-helper.cc
   DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/engines/python-helper.py ${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py
   )

add_custom_command(
   OUTPUT bash-helper.cc
   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py ${CMAKE_CURRENT_SOURCE_DIR}/engines/bash-helper.sh bash_helper > bash-helper.cc
   DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/engines/bash-helper.sh ${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py
   )

add_custom_command(
   OUTPUT html-data-files.cc
   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/bcov.css css_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/amber.png icon_amber
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/glass.png icon_glass
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/source-file.html source_file_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/index.html index_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/js/handlebars.js handlebars_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/js/kcov.js kcov_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/js/jquery.min.js jquery_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/js/jquery.tablesorter.min.js tablesorter_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/js/jquery.tablesorter.widgets.min.js tablesorter_widgets_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/tablesorter-theme.css tablesorter_theme_text
   > html-data-files.cc
   DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/bcov.css
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/amber.png
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/glass.png
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/source-file.html
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/index.html
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/js/handlebars.js
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/js/kcov.js
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/js/jquery.min.js
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/js/jquery.tablesorter.min.js
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/js/jquery.tablesorter.widgets.min.js
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/tablesorter-theme.css
    ${CMAKE_CURRENT_SOURCE_DIR}/bin-to-c-source.py
   )

# Reference: http://www.cmake.org/Wiki/CMake_RPATH_handling
if(SPECIFY_RPATH)
	set (CMAKE_SKIP_BUILD_RPATH  FALSE)
	set (CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
	set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
	# the RPATH to be used when installing, but only if it's not a system directory
	LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
	IF("${isSystemDir}" STREQUAL "-1")
	  SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
	ENDIF("${isSystemDir}" STREQUAL "-1")
endif(SPECIFY_RPATH)

add_executable (${KCOV} ${${KCOV}_SRCS} library.cc python-helper.cc bash-helper.cc html-data-files.cc)

target_link_libraries(${KCOV}
	${LIBDW_LIBRARIES}
	${LIBELF_LIBRARIES}
	stdc++
	dl
	pthread
	${LIBCURL_LIBRARIES}
	m
	${LIBZ_LIBRARIES})


install (TARGETS ${PROJECT_NAME} ${INSTALL_TARGETS_PATH})

file ( GLOB kcov-merge kcov-merge )

install (PROGRAMS ${kcov-merge} DESTINATION bin )

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -2,10 +2,30 @@
 
 project (kcov-tests)
 
+enable_language(ASM)
+
+include_directories(
+	${CMAKE_BINARY_DIR}
+	../src/include
+)
+set (CMAKE_CXX_FLAGS "-std=c++0x -Wall -D_GLIBCXX_USE_NANOSLEEP -DKCOV_LIBRARY_PREFIX=${KCOV_LIBRARY_PREFIX}")
+
+add_custom_command (OUTPUT multi-fork-generated.c
+  COMMAND ${CMAKE_SOURCE_DIR}/multi-fork/generate-functions.py ${CMAKE_SOURCE_DIR}/multi-fork/code-template.c 1024 > ${CMAKE_BINARY_DIR}/multi-fork-generated.c
+  DEPENDS
+	${CMAKE_SOURCE_DIR}/multi-fork/generate-functions.py
+)
+
+add_custom_target(multi-fork-generated ALL
+	DEPENDS multi-fork-generated.c
+)
+set_property(SOURCE multi-fork/test-multi-fork.c APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_BINARY_DIR}/multi-fork-generated.c)
+
+
 set (main_tests_SRCS
 	main.cc
 	subdir/file.c
-	subdir2/file.c
+	subdir2/file2.c
 )
 
 set (argv_dependent_SRCS
@@ -20,6 +40,14 @@
 	fork/fork-no-wait.c
 )
 
+set (signals_SRCS
+	signals/test-signals.c
+)
+
+set (multi_fork_SRCS
+	multi-fork/test-multi-fork.c
+)
+
 set (recursive-ptrace_SRCS
 	recursive-ptrace/main.cc
 )
@@ -32,9 +60,18 @@
 	popen/test-popen.c
 )
 
+set (global_constructors_SRCS
+	global-constructors/test-global-ctors.cc
+)
 
-add_library(shared_library SHARED shared-library/solib.c)
+set (daemon_SRCS
+	daemon/test-daemon.cc
+)
 
+add_library(shared_library SHARED
+	shared-library/big-symbol.S
+	shared-library/solib.c
+)
 
 set(CMAKE_BUILD_TYPE distribution)
 set(CMAKE_C_FLAGS_DISTRIBUTION "-g")
@@ -51,11 +88,43 @@
 add_executable(recursive-ptrace ${recursive-ptrace_SRCS})
 add_executable(fork ${fork_SRCS})
 add_executable(fork_no_wait ${fork_no_wait_SRCS})
+add_executable(signals ${signals_SRCS})
+add_executable(multi_fork ${multi_fork_SRCS})
 add_executable(shared_library_test ${shared_library_test_SRCS})
 add_executable(argv_dependent ${argv_dependent_SRCS})
 add_executable(test_popen ${test_popen_SRCS})
+add_executable(global-constructors ${global_constructors_SRCS})
+add_executable(test_daemon ${daemon_SRCS})
+add_executable(multi_1 merge-tests/file.c merge-tests/main_1.c)
+add_executable(multi_2 merge-tests/file.c merge-tests/main_2.c)
+add_executable(setpgid-kill setpgid-kill/setpgid-kill-main.cc ../src/utils.cc)
+add_executable(issue31 daemon/test-issue31.cc)
+add_executable(dlopen dlopen/dlopen.cc dlopen/dlopen-main.cc)
+
+add_executable(main-tests-gcov ${main_tests_SRCS})
+set_target_properties(main-tests-gcov PROPERTIES COMPILE_FLAGS "--coverage")
+set_target_properties(main-tests-gcov PROPERTIES LINK_FLAGS "--coverage")
+
+target_link_libraries(dlopen dl)
+
+
+add_custom_target (illegal-insn ALL
+  COMMAND ${CMAKE_C_COMPILER} -nostdlib ${CMAKE_CURRENT_SOURCE_DIR}/assembly/illegal-insn.S -o ${CMAKE_BINARY_DIR}/illegal-insn
+)
+
+add_custom_target (fork-32 ALL
+  COMMAND ${CMAKE_C_COMPILER} -g -m32 ${CMAKE_CURRENT_SOURCE_DIR}/fork/fork.c -o ${CMAKE_BINARY_DIR}/fork-32
+)
 
 target_link_libraries(shared_library_test shared_library)
+target_link_libraries(global-constructors shared_library)
+
+target_link_libraries(multi_fork
+	m)
+target_link_libraries(setpgid-kill
+	z)
+target_link_libraries(issue31
+	pthread)
 
 
 add_custom_target(tests-stripped ALL

=== tools/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project (kcov-tools)
set (CMAKE_MODULE_PATH  ${CMAKE_MODULE_PATH}
                        ${CMAKE_CURRENT_SOURCE_DIR}/../cmake)
find_package (LibElf REQUIRED)
find_package (Elfutils REQUIRED)
find_package (PkgConfig REQUIRED)
pkg_check_modules(LIBZ REQUIRED zlib)

# ====================================
# project name and version
# ====================================
set (LINE2ADDR line2addr)

set (${LINE2ADDR}_SRCS
    ../src/capabilities.cc
	../src/configuration.cc
	../src/filter.cc
	../src/gcov.cc
	../src/parsers/elf-parser.cc
	../src/parser-manager.cc
	../src/utils.cc
	line2addr.cc
	)


set (CMAKE_CXX_FLAGS "-std=c++0x -g -Wall -D_GLIBCXX_USE_NANOSLEEP -DKCOV_LIBRARY_PREFIX=${KCOV_LIBRARY_PREFIX}")

include_directories(
	../src/include/
	${LIBELF_INCLUDE_DIRS}
	${LIBDW_INCLUDE_DIRS}
	${LIBZ_INCLUDE_DIRS}
)

# Reference: http://www.cmake.org/Wiki/CMake_RPATH_handling
if(SPECIFY_RPATH)
	set (CMAKE_SKIP_BUILD_RPATH  FALSE)
	set (CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
	set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
	# the RPATH to be used when installing, but only if it's not a system directory
	LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
	IF("${isSystemDir}" STREQUAL "-1")
	  SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
	ENDIF("${isSystemDir}" STREQUAL "-1")
endif(SPECIFY_RPATH)

add_executable (${LINE2ADDR} ${${LINE2ADDR}_SRCS})

target_link_libraries(${LINE2ADDR}
	${LIBDW_LIBRARIES}
	${LIBELF_LIBRARIES}
	stdc++
	dl
	pthread
	m
	${LIBZ_LIBRARIES})

file ( GLOB kcov-merge kcov-merge )

install (PROGRAMS ${kcov-merge} DESTINATION bin )

=== travis/Makefile ===
#!/usr/bin/make

chroot=/tmp/32-bit-chroot
kcov_deps=libdw-dev libelf-dev elfutils libcurl4-openssl-dev python-pip python3 cmake

.PHONY: prepare_environment

build_reference:
	mkdir -p reference/src reference/build
	cd reference/ && git clone https://github.com/SimonKagstrom/kcov.git
	cd reference/kcov && git checkout v23
	cd reference/build && cmake ../kcov
	make -C reference/build/
	cp reference/build/src/kcov /tmp/kcov-reference

build:
	mkdir -p build build-tests build-tools
	cd build && cmake ..
	make -C build
	cd build-tools && cmake ../tools
	make -C build-tools
	sudo make -C build install
	cd build-tests && cmake ../tests
	make -C build-tests

build_gcc: build_reference
	sudo rm -rf ${chroot}/tmp/kcov/build ${chroot}/tmp/kcov/build-tests
	sudo mkdir -p ${chroot}/tmp/kcov/build ${chroot}/tmp/kcov/build-tests ${chroot}/tmp/kcov/build-tools
	sudo i386 chroot ${chroot} sh -c "cd /tmp/kcov/build && cmake .."
	sudo i386 chroot ${chroot} sh -c "make -C /tmp/kcov/build"
	sudo i386 chroot ${chroot} sh -c "make -C /tmp/kcov/build install"
	sudo i386 chroot ${chroot} sh -c "cd /tmp/kcov/build-tools && cmake ../tools"
	sudo i386 chroot ${chroot} sh -c "make -C /tmp/kcov/build-tools"
	sudo i386 chroot ${chroot} sh -c "cd /tmp/kcov/build-tests && cmake ../tests"
	sudo i386 chroot ${chroot} sh -c "make -C /tmp/kcov/build-tests"

run-performance: build_gcc
	travis/perf-test.sh build/src/kcov . build >/dev/null
	/usr/bin/time -f "%e" travis/perf-test.sh build/src/kcov . build >/dev/null
	rm -rf /tmp/kcov-perf
	travis/perf-test.sh /tmp/kcov-reference . build >/dev/null
	/usr/bin/time -f "%e" travis/perf-test.sh /tmp/kcov-reference . build >/dev/null

run-tests-gcc: run-performance
	sudo i386 chroot ${chroot} sh -c "cd /tmp/kcov/build-tests && WORKSPACE=/tmp/kcov/ pybot --noncritical not_ready ../tests/robot-framework/kcov-tests.txt"
	cd build-tests && WORKSPACE=`pwd`/../ pybot --noncritical not_ready ../tests/robot-framework/kcov-tests.txt
	build/src/kcov --coveralls-id=$(TRAVIS_JOB_ID) --include-pattern=kcov --exclude-pattern=helper.cc,library.cc,html-data-files.cc /tmp/kcov-kcov build/src/kcov || true

run-tests-clang:
	cd build-tests && WORKSPACE=`pwd`/../ pybot --noncritical not_ready ../tests/robot-framework/kcov-tests.txt

build_clang:

run-tests: build run-tests-${CC}

prepare_linux:
	sudo apt-get update -qq
	sudo apt-get install -y ${kcov_deps} gcc-multilib debootstrap git time
	sudo pip install robotframework

prepare_gcc:
	sudo i386 debootstrap --arch=i386 --components=main,universe  precise $(chroot)
	sudo i386 chroot "${chroot}" apt-get update
	sudo i386 chroot "${chroot}" apt-get install -y build-essential
	sudo i386 chroot "${chroot}" apt-get install -y ${kcov_deps}
	sudo i386 chroot "${chroot}" pip install robotframework
	sudo cp -r "$(shell pwd)" "${chroot}/tmp/"
	sudo i386 chroot "${chroot}" sh -c "mount -t proc procfs /proc"


prepare_clang:

prepare_environment: prepare_linux prepare_${CC}

=== src/kernel/Makefile ===
KDIR := /lib/modules/$(shell uname -r)/build
PWD := $(shell pwd)

CFLAGS_kprobe-coverage.o += -g3

obj-m += kprobe-coverage.o

default:
	$(MAKE) -C $(KDIR) SUBDIRS=$(PWD) modules

clean:
	rm -f *.o *.ko *.order *.symvers *.mod.c

=== tests/unit-tests/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project (kcov-ut)
set (CMAKE_MODULE_PATH  ${CMAKE_MODULE_PATH}
                        ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake)
find_package (LibCRPCUT REQUIRED)
find_package (LibElf REQUIRED)
find_package (Elfutils REQUIRED)

# ====================================
# project name and version
# ====================================
project (unit-test)
set (TGT ut)

set (${TGT}_SRCS
    ../../src/capabilities.cc
    ../../src/collector.cc
    ../../src/engine-factory.cc
    ../../src/gcov.cc
    ../../src/output-handler.cc
    ../../src/parsers/elf-parser.cc
    ../../src/parser-manager.cc
    ../../src/utils.cc
    ../../src/writers/cobertura-writer.cc
    ../../src/writers/html-writer.cc
    ../../src/writers/writer-base.cc
    main.cc
    tests-collector.cc
    tests-configuration.cc
    tests-elf.cc
    tests-filter.cc
    tests-merge-parser.cc
    tests-reporter.cc
    tests-utils.cc
    tests-writer.cc
    )
set (CMAKE_BUILD_TYPE debug)

set (CMAKE_CXX_FLAGS "-std=c++1y -Wall -D_GLIBCXX_USE_NANOSLEEP")


add_custom_command(
   OUTPUT html-data-files.cc
   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../../src/bin-to-c-source.py
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/bcov.css css_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/amber.png icon_amber
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/glass.png icon_glass
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/source-file.html source_file_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/index.html index_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/handlebars.js handlebars_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/kcov.js kcov_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/jquery.min.js jquery_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/jquery.tablesorter.min.js tablesorter_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/jquery.tablesorter.widgets.min.js tablesorter_widgets_text
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/tablesorter-theme.css tablesorter_theme_text
   > html-data-files.cc
   DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/bcov.css
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/amber.png
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/glass.png
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/source-file.html
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/index.html
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/handlebars.js
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/kcov.js
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/jquery.min.js
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/jquery.tablesorter.min.js
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/js/jquery.tablesorter.widgets.min.js
    ${CMAKE_CURRENT_SOURCE_DIR}/../../data/tablesorter-theme.css
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/bin-to-c-source.py
   )

include_directories(
	../../src/include/
	${LIBCRPCUT_INCLUDE_DIRS}
	${LIBELF_INCLUDE_DIRS}
	${LIBDW_INCLUDE_DIRS}
	)

link_directories (/home/ska/local/lib)

add_executable (${TGT} ${${TGT}_SRCS} html-data-files.cc)

target_link_libraries(${TGT}
	${LIBCRPCUT_LIBRARIES}
	${LIBDW_LIBRARIES}
	${LIBELF_LIBRARIES}
	dl
	z
	pthread)

add_executable (same-name-test
	../main.cc
	../subdir/file.c
	../subdir2/file.c
)
  
add_executable (test-binary test-source.c second-source.c)
SET_TARGET_PROPERTIES(test-binary PROPERTIES COMPILE_FLAGS "-nostdinc")
SET_TARGET_PROPERTIES(test-binary PROPERTIES LINK_FLAGS "-nostdlib")

=== debian/changelog ===
kcov (25+dfsg-1ubuntu2) vivid; urgency=medium

  * Don't build fork-32, doesn't build everywhere.
  * Disable the assembly test, architecture specific.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 16 Mar 2015 20:41:30 +0100

kcov (25+dfsg-1ubuntu1) vivid; urgency=medium

  * Build the library with -fPIC.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 16 Mar 2015 20:23:07 +0100

kcov (25+dfsg-1) unstable; urgency=low

  * New upstream version (closes: #775477)
    - adds support for PowerPC, ARM
    - use upstream man page
    - removed jquery minimised javascript
  * Bump Standards Version to 3.9.6 (no changes)
  * Will attempt to build on all variants of x86, powerpc, arm

 -- Michael Tautschnig <mt@debian.org>  Sun, 15 Feb 2015 17:57:59 +0000

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,10 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
+
 %:
 	dh $@ 
 
@@ -17,23 +21,27 @@
 	dh_auto_clean
 	dh_clean
 	rm -rf obj-* CMakeFiles CMakeCache.txt
-	rm -rf tests-build
+	rm -rf tests-build kcov
+	rm -f tests/python/second.pyc
+	rm -f tests/python/unittest/unitundertest.pyc
+	rm -rf debian/robotframework-2.8.7
+	rm -f build
 
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
 ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
 override_dh_auto_test:
 	dh_testdir
+	cd debian ; tar xzf robotframework-2.8.7.tar.gz
+	cd debian/robotframework-2.8.7 && python setup.py build
 	mkdir tests-build
 	cd tests-build ; cmake ../tests/
 	$(MAKE) -C tests-build
-	ls
-	cd tests-build ; export PATH=`echo $$PWD/../obj-*/src`:$$PATH ; \
-		sh run-all.sh 2>&1 | tee tests.log
-	rm -rf /tmp/kcov
-	if grep -q FAIL tests-build/tests.log ; then \
-		echo "Test suite failure" ; \
-		exit 1 ; \
-	fi
+	ln -s obj-* build
+	# need to debug tests first
+	#export PYTHONPATH=`echo $$PWD/debian/robotframework-2.8.7/build/lib.linux-*/`:$$PYTHONPATH ; \
+	#	export PATH=`echo $$PWD/debian/robotframework-2.8.7/build/scripts-*/`:$$PATH ; \
+	#	cd tests-build && \
+	#	WORKSPACE=$$PWD/../ pybot --noncritical not_ready ../tests/robot-framework/kcov-tests.txt
 endif
 endif
